/*
 * Copyright © 2025 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#pragma once

#include "src/core/handler_registration.h"

using HighBrightnessModeHandler = std::function<void(bool)>;

namespace repowerd
{

class HighBrightnessMode
{
public:
    virtual ~HighBrightnessMode() = default;

    virtual void set_enabled(bool enabled) = 0;
    virtual bool get_enabled() = 0;
    virtual bool is_supported() const = 0;

    virtual HandlerRegistration register_high_brightness_mode_handler(
        HighBrightnessModeHandler const& handler) = 0;

protected:
    HighBrightnessMode() = default;
    HighBrightnessMode(HighBrightnessMode const&) = delete;
    HighBrightnessMode& operator=(HighBrightnessMode const&) = delete;
};

}
